From e2b803d463900cc41560261ab12382af67ea72eb Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: May 21 2015 16:21:59 +0000
Subject: [PATCH 17/1001] Rework the widget API to separate data and presentation.


---

diff --git a/hubs/models.py b/hubs/models.py
index c8c006a..660bb9f 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -150,8 +150,8 @@ class Widget(BASE):
         }
 
     def render(self, request, session):
-        plugin = widgets.registry[self.plugin]
-        return plugin(request, session, self, **self.config)
+        module = widgets.registry[self.plugin]
+        return widgets.render(module, request, session, self, **self.config)
 
 
 class User(BASE):
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 2e495f7..1c83230 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -4,8 +4,50 @@ import rules
 import sticky
 
 registry = {
-    'dummy': dummy.render,
-    'stats': stats.render,
-    'rules': rules.render,
-    'sticky': sticky.render,
+    'dummy': dummy,
+    'stats': stats,
+    'rules': rules,
+    'sticky': sticky,
 }
+
+
+def validate_registry(registry):
+    """ Ensure that the widgets in the registry have the bits they need.
+    - Check that a template is available and has a render callable.
+    - Look for a data function, etc..
+    - Ensure it has the right number of arguments, do things to help debugging.
+    """
+    raise NotImplementedError()
+    for name, module in registry.items():
+        pass
+
+def prepare_registry(registry):
+    """ Do things ahead of time that we can to the registry.
+    - Wrap a cache layer around the data functions.
+    - Wrap any chrome around the render functions.
+    """
+    for name, module in registry.items():
+        # Wrap chrome around the render function
+        module.render = module.template.render
+        if hasattr(module, 'chrome'):
+            module.render = module.chrome(module.render)
+
+        # TODO -- wrap a cache layer around the data functions
+        #         do this only if the module provides a cache invalidator
+        #         and warn in the logs if there's not one present?
+
+# TODO -- actually call this
+#validate_registry(registry)
+prepare_registry(registry)
+
+def render(module, *args, **kwargs):
+    """ Main API entry point.
+
+    Call this to render a widget into HTML
+    """
+
+    # The API returns exactly this data.  Shared cache
+    data = module.data(*args, **kwargs)
+
+    # Use the API data to fill out a template, and potentially decorate it.
+    return module.render(**data)
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index a35e9d2..68119b5 100644
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -1,11 +1,16 @@
 from chrome import panel
 from base import argument
 
+import jinja2
+
 import hubs.validators as validators
 
-@panel("This is a dummy widget")
+
+template = jinja2.Template("{{text}}")
+chrome = panel("This is a dummy widget")
+
 @argument(name="text", default="Lorem ipsum dolor...",
           validator=validators.text,
           help="Some dummy text to display.")
-def render(request, session, widget, text):
-    return text
+def data(request, session, widget, text):
+    return dict(text=text)
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
index f6d2ee0..2a6a632 100644
--- a/hubs/widgets/rules.py
+++ b/hubs/widgets/rules.py
@@ -6,7 +6,8 @@ from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument, avatar
 from hubs import validators
 
-rules_template = jinja2.Template("""
+chrome = panel()
+template = jinja2.Template("""
 <div class="rules-container">
   {% if link %}
   <p class="small-heading">community rules</p>
@@ -35,11 +36,10 @@ rules_template = jinja2.Template("""
 </style>
 """)
 
-@panel()
 @argument(name='link', default=None,
           validator=validators.link,
           help="Link to the community rules and guidelines")
-def render(request, session, widget, link):
+def data(request, session, widget, link):
     owners = widget.hub.owners
     owners = ordereddict([(o, avatar(o)) for o in owners])
-    return rules_template.render(owners=owners, link=link)
+    return dict(owners=owners, link=link)
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index d7a1609..c5dbea0 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -1,36 +1,38 @@
 from chrome import panel
 
-stats_template = """
+import jinja2
+
+chrome = panel()
+template = jinja2.Template("""
 <div class="stats-container">
   <table class="stats-table">
     <tr><th>Members</th><th>Subscribers</th></tr>
-    <tr class="text-info"><td>{members}</td><td>{subscribers}</td></tr>
+    <tr class="text-info"><td>{{members}}</td><td>{{subscribers}}</td></tr>
   </table>
   <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
 </div>
 <style>
-  .stats-table {{
+  .stats-table {
     width: 180px
     padding: 0px;
     margin: 0px;
     display: inline-block;
-  }}
-  .stats-table th {{
+  }
+  .stats-table th {
     text-transform: uppercase;
     font-size: 80%;
     padding-right: 10px;
     color: #797a7c;
-  }}
-  .stats-table td {{
+  }
+  .stats-table td {
     font-size: 32pt;
-  }}
-
+  }
 </style>
-"""
+""")
+
 
-@panel()
-def render(request, session, widget):
-    return stats_template.format(
+def data(request, session, widget):
+    return dict(
         members=len(widget.hub.members),
         subscribers=len(widget.hub.subscribers),
     )
diff --git a/hubs/widgets/sticky.py b/hubs/widgets/sticky.py
index 2246ae1..416fd0e 100644
--- a/hubs/widgets/sticky.py
+++ b/hubs/widgets/sticky.py
@@ -1,12 +1,17 @@
 from chrome import panel
 from base import argument
 
+import jinja2
+
 import hubs.validators as validators
 
-@panel(title='Sticky Note', klass="panel-info")
+template = jinja2.Template("{{text}}")
+
+chrome = panel(title='Sticky Note', klass="panel-info")
+
 @argument(name="text", default="Lorem ipsum dolor...",
           validator=validators.text,
           help="Some dummy text to display.")
-def render(request, session, widget, text):
+def data(request, session, widget, text):
     # TODO -- render with markdown
-    return text
+    return dict(text=text)

